Index: squid/src/store_dir_ufs.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/store_dir_ufs.c,v
retrieving revision 1.1.1.1.4.1.2.2
retrieving revision 1.1.1.1.4.1.2.3
diff -u -r1.1.1.1.4.1.2.2 -r1.1.1.1.4.1.2.3
--- squid/src/store_dir_ufs.c	3 Jun 2001 19:41:49 -0000	1.1.1.1.4.1.2.2
+++ squid/src/store_dir_ufs.c	14 Jun 2001 20:36:16 -0000	1.1.1.1.4.1.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir_ufs.c,v 1.1.1.1.4.1.2.2 2001/06/03 19:41:49 serassio Exp $
+ * $Id: store_dir_ufs.c,v 1.1.1.1.4.1.2.3 2001/06/14 20:36:16 serassio Exp $
  *
  * DEBUG: section 47    Store Directory Routines
  * AUTHOR: Duane Wessels
@@ -264,6 +264,7 @@
     if (!started_clean_event) {
 	eventAdd("storeDirClean", storeUfsDirCleanEvent, NULL, 15.0, 1);
 	started_clean_event = 1;
+    (void) storeDirGetBlkSize(sd->path, &sd->fs.blksize);
     }
 }
 
@@ -790,6 +791,7 @@
     }
     sd->u.ufs.swaplog_fd = fd;
     /* open a read-only stream of the old log */
+    fp = fopen(swaplog_path, "r");
     if (fp == NULL) {
 	debug(50, 0) ("%s: %s\n", swaplog_path, xstrerror());
 	fatal("Failed to open swap log for reading");
@@ -1157,14 +1159,19 @@
 {
     int i;
     SwapDir *SD;
-#if HAVE_STATVFS
-    struct statvfs sfs;
-#endif
+    int totl_kb = 0;
+    int free_kb = 0;
+    int totl_in = 0;
+    int free_in = 0;
+    int x;
+
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
 	SD = &Config.cacheSwap.swapDirs[i];
 	storeAppendPrintf(sentry, "\n");
 	storeAppendPrintf(sentry, "Store Directory #%d: %s\n", i, SD->path);
-	storeAppendPrintf(sentry, "First level subdirectories: %d\n", SD->u.ufs.l1);
+	storeAppendPrintf(sentry, "FS Block Size %d Bytes\n",
+	    SD->fs.blksize);
+    storeAppendPrintf(sentry, "First level subdirectories: %d\n", SD->u.ufs.l1);
 	storeAppendPrintf(sentry, "Second level subdirectories: %d\n", SD->u.ufs.l2);
 	storeAppendPrintf(sentry, "Maximum Size: %d KB\n", SD->max_size);
 	storeAppendPrintf(sentry, "Current Size: %d KB\n", SD->cur_size);
@@ -1173,20 +1180,17 @@
 	storeAppendPrintf(sentry, "Filemap bits in use: %d of %d (%d%%)\n",
 	    SD->map->n_files_in_map, SD->map->max_n_files,
 	    percent(SD->map->n_files_in_map, SD->map->max_n_files));
-#if HAVE_STATVFS
-#define fsbtoblk(num, fsbs, bs) \
-        (((fsbs) != 0 && (fsbs) < (bs)) ? \
-                (num) / ((bs) / (fsbs)) : (num) * ((fsbs) / (bs)))
-	if (!statvfs(SD->path, &sfs)) {
-	    storeAppendPrintf(sentry, "Filesystem Space in use: %d/%d KB (%d%%)\n",
-		fsbtoblk((sfs.f_blocks - sfs.f_bfree), sfs.f_frsize, 1024),
-		fsbtoblk(sfs.f_blocks, sfs.f_frsize, 1024),
-		percent(sfs.f_blocks - sfs.f_bfree, sfs.f_blocks));
-	    storeAppendPrintf(sentry, "Filesystem Inodes in use: %d/%d (%d%%)\n",
-		sfs.f_files - sfs.f_ffree, sfs.f_files,
-		percent(sfs.f_files - sfs.f_ffree, sfs.f_files));
-	}
-#endif
+    x = storeDirGetUFSStats(SD->path, &totl_kb, &free_kb, &totl_in, &free_in);
+    if (0 == x) {
+	storeAppendPrintf(sentry, "Filesystem Space in use: %d/%d KB (%d%%)\n",
+	    totl_kb - free_kb,
+	    totl_kb,
+	    percent(totl_kb - free_kb, totl_kb));
+	storeAppendPrintf(sentry, "Filesystem Inodes in use: %d/%d (%d%%)\n",
+	    totl_in - free_in,
+	    totl_in,
+	    percent(totl_in - free_in, totl_in));
+    }
 	storeAppendPrintf(sentry, "Flags:");
 	if (SD->flags.selected)
 	    storeAppendPrintf(sentry, " SELECTED");
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.1.1.3.4.2.2.2
retrieving revision 1.1.1.3.4.2.2.3
diff -u -r1.1.1.3.4.2.2.2 -r1.1.1.3.4.2.2.3
--- squid/src/structs.h	3 Jun 2001 19:41:49 -0000	1.1.1.3.4.2.2.2
+++ squid/src/structs.h	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.2.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.1.1.3.4.2.2.2 2001/06/03 19:41:49 serassio Exp $
+ * $Id: structs.h,v 1.1.1.3.4.2.2.3 2001/06/14 20:36:16 serassio Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -601,6 +601,18 @@
     CommWriteStateData *rwstate;	/* State data for comm_write */
 };
 
+struct statfs {
+   long    f_type;     /* type of filesystem (see below) */
+   long    f_bsize;    /* optimal transfer block size */
+   long    f_blocks;   /* total data blocks in file system */
+   long    f_bfree;    /* free blocks in fs */
+   long    f_bavail;   /* free blocks avail to non-superuser */
+   long    f_files;    /* total file nodes in file system */
+   long    f_ffree;    /* free file nodes in fs */
+   long    f_fsid;     /* file system id */
+   long    f_namelen;  /* maximum length of filenames */
+   long    f_spare[6]; /* spare for later */
+};
 #endif
 
 
@@ -1394,6 +1406,9 @@
 	    void *state;
 	} clean;
     } log;
+    struct {
+	int blksize;
+    } fs;
     union {
 	struct {
 	    int l1;
Index: squid/src/tools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/tools.c,v
retrieving revision 1.1.1.3.4.1.2.3
retrieving revision 1.1.1.3.4.1.2.4
diff -u -r1.1.1.3.4.1.2.3 -r1.1.1.3.4.1.2.4
--- squid/src/tools.c	3 Jun 2001 19:41:49 -0000	1.1.1.3.4.1.2.3
+++ squid/src/tools.c	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.1.2.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: tools.c,v 1.1.1.3.4.1.2.3 2001/06/03 19:41:49 serassio Exp $
+ * $Id: tools.c,v 1.1.1.3.4.1.2.4 2001/06/14 20:36:16 serassio Exp $
  *
  * DEBUG: section 21    Misc Functions
  * AUTHOR: Harvest Derived
@@ -34,10 +34,15 @@
  */
 
 #include "squid.h"
-#ifdef _SQUID_MSWIN_
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+#include <windows.h>
+#include <psapi.h>
 #include <process.h>
+#ifdef _SQUID_MSWIN_
 #include <sys/timeb.h>
 #endif
+#endif
+
 #define DEAD_MSG "\
 The Squid Cache (version %s) died.\n\
 \n\
@@ -176,41 +181,49 @@
 void
 squid_getrusage(struct rusage *r)
 {
-#ifdef _SQUID_MSWIN_
-    HANDLE hProcess;
-    PROCESS_MEMORY_COUNTERS pmc;
-	FILETIME ftCreate, ftExit, ftKernel, ftUser;
-#endif
     memset(r, '\0', sizeof(struct rusage));
-#ifdef _SQUID_MSWIN_
-    hProcess = OpenProcess(  PROCESS_QUERY_INFORMATION |
-                                    PROCESS_VM_READ,
-                                    FALSE, GetCurrentProcessId() );
-
-    if ( GetProcessTimes( hProcess, &ftCreate, &ftExit, &ftKernel, &ftUser))
-	{
-        LONGLONG tUser64 = *(LONGLONG *)&ftUser;
-        LONGLONG tKernel64 = *(LONGLONG *)&ftKernel;
-		r->ru_utime.tv_usec =(DWORD)(tUser64 / 10);
-		r->ru_stime.tv_usec =(DWORD)(tKernel64 / 10);
-	}
-
-    if ( GetProcessMemoryInfo( hProcess, &pmc, sizeof(pmc)) )
-    {
-		r->ru_maxrss=(DWORD)(pmc.WorkingSetSize /1024);
-		r->ru_majflt=pmc.PageFaultCount;
-	}
-	CloseHandle( hProcess );
-#else
-#if HAVE_GETRUSAGE && defined(RUSAGE_SELF)
+#if (HAVE_GETRUSAGE && defined(RUSAGE_SELF)) || defined(_SQUID_MSWIN_)
 #ifdef _SQUID_SOLARIS_
     /* Solaris 2.5 has getrusage() permission bug -- Arjan de Vet */
     enter_suid();
 #endif
+#ifndef _SQUID_MSWIN_
     getrusage(RUSAGE_SELF, r);
+#endif
 #ifdef _SQUID_SOLARIS_
     leave_suid();
 #endif
+#if HAVE_WIN32_PSAPI && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    if ((WIN32_OS_version == _WIN_OS_WINNT) || (WIN32_OS_version == _WIN_OS_WIN2K))
+    {
+    	/* On Windows NT/2000 call PSAPI.DLL for process Memory */
+    	/* informations -- Guido Serassio                       */
+    	HANDLE hProcess;
+    	PROCESS_MEMORY_COUNTERS pmc;
+	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION |
+	    PROCESS_VM_READ,
+	    FALSE, GetCurrentProcessId());
+#if defined (_SQUID_MSWIN_)
+	{
+	/* Microsoft Visual C++ doesn't have getrusage function,  */
+	/* so we get process CPU time information from PSAPI.DLL. */
+	    FILETIME ftCreate, ftExit, ftKernel, ftUser;
+	    if (GetProcessTimes(hProcess, &ftCreate, &ftExit, &ftKernel, &ftUser))
+	    {
+	    	LONGLONG tUser64 = *(LONGLONG *)&ftUser;
+		LONGLONG tKernel64 = *(LONGLONG *)&ftKernel;
+		r->ru_utime.tv_usec =(DWORD)(tUser64 / 10);
+		r->ru_stime.tv_usec =(DWORD)(tKernel64 / 10);
+	    }
+	}
+#endif
+	if ( GetProcessMemoryInfo( hProcess, &pmc, sizeof(pmc)) )
+	{
+	    r->ru_maxrss=(DWORD)(pmc.WorkingSetSize /1024);
+	    r->ru_majflt=pmc.PageFaultCount;
+	}
+	CloseHandle( hProcess );
+    }
 #endif
 #endif
 }
@@ -378,8 +391,8 @@
     if (0 == store_dirs_rebuilding)
 	storeDirWriteCleanLogs(0);
     fatal_common(message);
-#ifdef _SQUID_MSWIN_
-		ServiceExit(shutting_down ? 0 : 1);
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+    WIN32_Exit(shutting_down ? 0 : 1);
 #else
     exit(shutting_down ? 0 : 1);
 #endif
@@ -569,8 +582,8 @@
 void
 enter_suid(void)
 {
-#ifndef _SQUID_MSWIN_
     debug(21, 3) ("enter_suid: PID %d taking root priveleges\n", getpid());
+#ifndef _SQUID_MSWIN_
 #if HAVE_SETRESUID
     setresuid(-1, 0, -1);
 #else
@@ -721,15 +734,6 @@
 #endif /* RLIMIT_VMEM */
 }
 
-#ifdef _SQUID_MSWIN_
-void gettimeofday( struct timeval * pcur_time,void * tz){
-	struct _timeb current;
-	_ftime(&current);
-	pcur_time->tv_sec=current.time;
-	pcur_time->tv_usec=current.millitm * 1000;
-}
-#endif
-
 time_t
 getCurrentTime(void)
 {
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.1.1.3.4.1.2.2
retrieving revision 1.1.1.3.4.1.2.3
diff -u -r1.1.1.3.4.1.2.2 -r1.1.1.3.4.1.2.3
--- squid/src/typedefs.h	3 Jun 2001 19:41:49 -0000	1.1.1.3.4.1.2.2
+++ squid/src/typedefs.h	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.1.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.1.1.3.4.1.2.2 2001/06/03 19:41:49 serassio Exp $
+ * $Id: typedefs.h,v 1.1.1.3.4.1.2.3 2001/06/14 20:36:16 serassio Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
Index: squid/src/url.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/url.c,v
retrieving revision 1.1.1.3.4.4.2.1
retrieving revision 1.1.1.3.4.4.2.2
diff -u -r1.1.1.3.4.4.2.1 -r1.1.1.3.4.4.2.2
--- squid/src/url.c	6 Jan 2001 12:40:17 -0000	1.1.1.3.4.4.2.1
+++ squid/src/url.c	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.4.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: url.c,v 1.1.1.3.4.4.2.1 2001/01/06 12:40:17 hno Exp $
+ * $Id: url.c,v 1.1.1.3.4.4.2.2 2001/06/14 20:36:16 serassio Exp $
  *
  * DEBUG: section 23    URL Parsing
  * AUTHOR: Duane Wessels
@@ -278,7 +278,7 @@
 	host[l] = '\0';
     /* remove duplicate dots */
     while ((t = strstr(host, "..")))
-	xmemmove(t, t + 1, strlen(t));
+	    xmemmove(t, t + 1, strlen(t));
     if (Config.appendDomain && !strchr(host, '.'))
 	strncat(host, Config.appendDomain, SQUIDHOSTNAMELEN);
     if (port == 0) {
Index: squid/src/useragent.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/useragent.c,v
retrieving revision 1.1.1.3.4.1.2.2
retrieving revision 1.1.1.3.4.1.2.3
diff -u -r1.1.1.3.4.1.2.2 -r1.1.1.3.4.1.2.3
--- squid/src/useragent.c	3 Jun 2001 19:41:49 -0000	1.1.1.3.4.1.2.2
+++ squid/src/useragent.c	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.1.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: useragent.c,v 1.1.1.3.4.1.2.2 2001/06/03 19:41:49 serassio Exp $
+ * $Id: useragent.c,v 1.1.1.3.4.1.2.3 2001/06/14 20:36:16 serassio Exp $
  *
  * DEBUG: section 40    User-Agent logging
  * AUTHOR: Joe Ramey <ramey@csc.ti.com>
